﻿
Friend Class FIFO_GRAPHIC

    Private FifoMaxLength As Int32
    Private WriteIndex As Int32
    Private Buffer_ShowCandles() As Boolean
    Private Buffer_Value() As Single
    Private Buffer_MaxCandle() As Single
    Private Buffer_MinCandle() As Single
    Private Buffer_VerticalMarkerLength() As Int32

    Friend Sub New(ByVal length As Int32)
        FifoMaxLength = length
        ReDim Buffer_ShowCandles(FifoMaxLength - 1)
        ReDim Buffer_Value(FifoMaxLength - 1)
        ReDim Buffer_MaxCandle(FifoMaxLength - 1)
        ReDim Buffer_MinCandle(FifoMaxLength - 1)
        ReDim Buffer_VerticalMarkerLength(FifoMaxLength - 1)
        FillWithZero()
        WriteIndex = 0
    End Sub

    Private Sub FillWithZero()
        For i As Int32 = 0 To Buffer_Value.Length - 1
            Buffer_Value(i) = 0
            'Buffer_MaxCandle(i) = 0
            'Buffer_MinCandle(i) = 0
        Next
    End Sub

    Friend Sub AddElement(ByVal Value As Single, _
                          ByVal ShowCandles As Boolean, _
                          ByVal MaxCandle As Single, _
                          ByVal MinCandle As Single, _
                          ByVal VerticalMarkerLength As Int32)

        Buffer_ShowCandles(WriteIndex) = ShowCandles
        Buffer_Value(WriteIndex) = Value
        Buffer_MaxCandle(WriteIndex) = MaxCandle
        Buffer_MinCandle(WriteIndex) = MinCandle
        Buffer_VerticalMarkerLength(WriteIndex) = VerticalMarkerLength
        WriteIndex += 1
        If WriteIndex >= FifoMaxLength Then WriteIndex = 0
    End Sub

    Friend Sub GetElement(ByVal distance As Int32, _
                          ByRef Value As Single, _
                          ByRef ShowCandles As Boolean, _
                          ByRef MaxCandle As Single, _
                          ByRef MinCandle As Single, _
                          ByRef VerticalMarkerLength As Int32, _
                          ByRef VerticalMarkercolor As Int32)
        '
        If distance >= FifoMaxLength Then
            Value = 0
            MaxCandle = 0
            MinCandle = 0
            VerticalMarkerLength = 0
            Return
        End If
        '
        Dim i As Int32 = WriteIndex - distance
        If i < 0 Then i += FifoMaxLength
        '
        ShowCandles = Buffer_ShowCandles(i)
        Value = Buffer_Value(i)
        MaxCandle = Buffer_MaxCandle(i)
        MinCandle = Buffer_MinCandle(i)
        VerticalMarkerLength = Buffer_VerticalMarkerLength(i)
    End Sub

    Friend ReadOnly Property Length() As Int32
        Get
            Return FifoMaxLength
        End Get
    End Property

End Class
